/*
 * bootstrap-modbox - Native JavaScript wrapper for simple Bootstrap 5 modals. Provides support for alert, confirm, and prompt modals, as well as advanced custom dialogs.
 * version: 1.0.0
 * author: Eric Robertson
 * license: MIT
 *
 * https://erobertson42.github.io/bootstrap-modbox/
 */

"use strict";function _slicedToArray(t,e){return _arrayWithHoles(t)||_iterableToArrayLimit(t,e)||_unsupportedIterableToArray(t,e)||_nonIterableRest()}function _nonIterableRest(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}function _iterableToArrayLimit(t,e){var o=null==t?null:"undefined"!=typeof Symbol&&t[Symbol.iterator]||t["@@iterator"];if(null!=o){var a,n,i=[],r=!0,l=!1;try{for(o=o.call(t);!(r=(a=o.next()).done)&&(i.push(a.value),!e||i.length!==e);r=!0);}catch(t){l=!0,n=t}finally{try{r||null==o.return||o.return()}finally{if(l)throw n}}return i}}function _arrayWithHoles(t){if(Array.isArray(t))return t}function _toConsumableArray(t){return _arrayWithoutHoles(t)||_iterableToArray(t)||_unsupportedIterableToArray(t)||_nonIterableSpread()}function _nonIterableSpread(){throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}function _unsupportedIterableToArray(t,e){if(t){if("string"==typeof t)return _arrayLikeToArray(t,e);var o=Object.prototype.toString.call(t).slice(8,-1);return"Map"===(o="Object"===o&&t.constructor?t.constructor.name:o)||"Set"===o?Array.from(t):"Arguments"===o||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(o)?_arrayLikeToArray(t,e):void 0}}function _iterableToArray(t){if("undefined"!=typeof Symbol&&null!=t[Symbol.iterator]||null!=t["@@iterator"])return Array.from(t)}function _arrayWithoutHoles(t){if(Array.isArray(t))return _arrayLikeToArray(t)}function _arrayLikeToArray(t,e){(null==e||e>t.length)&&(e=t.length);for(var o=0,a=new Array(e);o<e;o++)a[o]=t[o];return a}function ownKeys(e,t){var o,a=Object.keys(e);return Object.getOwnPropertySymbols&&(o=Object.getOwnPropertySymbols(e),t&&(o=o.filter(function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable})),a.push.apply(a,o)),a}function _objectSpread(e){for(var t=1;t<arguments.length;t++){var o=null!=arguments[t]?arguments[t]:{};t%2?ownKeys(Object(o),!0).forEach(function(t){_defineProperty(e,t,o[t])}):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(o)):ownKeys(Object(o)).forEach(function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(o,t))})}return e}function _classCallCheck(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}function _defineProperties(t,e){for(var o=0;o<e.length;o++){var a=e[o];a.enumerable=a.enumerable||!1,a.configurable=!0,"value"in a&&(a.writable=!0),Object.defineProperty(t,a.key,a)}}function _createClass(t,e,o){return e&&_defineProperties(t.prototype,e),o&&_defineProperties(t,o),t}function _classPrivateMethodInitSpec(t,e){_checkPrivateRedeclaration(t,e),e.add(t)}function _classPrivateFieldInitSpec(t,e,o){_checkPrivateRedeclaration(t,e),e.set(t,o)}function _checkPrivateRedeclaration(t,e){if(e.has(t))throw new TypeError("Cannot initialize the same private elements twice on an object")}function _defineProperty(t,e,o){return e in t?Object.defineProperty(t,e,{value:o,enumerable:!0,configurable:!0,writable:!0}):t[e]=o,t}function _classPrivateMethodGet(t,e,o){if(!e.has(t))throw new TypeError("attempted to get private field on non-instance");return o}function _classPrivateFieldSet(t,e,o){return _classApplyDescriptorSet(t,_classExtractFieldDescriptor(t,e,"set"),o),o}function _classApplyDescriptorSet(t,e,o){if(e.set)e.set.call(t,o);else{if(!e.writable)throw new TypeError("attempted to set read only private field");e.value=o}}function _classPrivateFieldGet(t,e){return _classApplyDescriptorGet(t,_classExtractFieldDescriptor(t,e,"get"))}function _classExtractFieldDescriptor(t,e,o){if(!e.has(t))throw new TypeError("attempted to "+o+" private field on non-instance");return e.get(t)}function _classApplyDescriptorGet(t,e){return e.get?e.get.call(t):e.value}function _classStaticPrivateMethodGet(t,e,o){return _classCheckPrivateStaticAccess(t,e),o}function _classCheckPrivateStaticAccess(t,e){if(t!==e)throw new TypeError("Private static access of wrong provenance")}var _options=new WeakMap,_modal=new WeakMap,_modalEl=new WeakMap,_footer=new WeakMap,_getDefaultButtonOptions=new WeakSet,_buildModal=new WeakSet,_addButtons=new WeakSet,_addEvents=new WeakSet,modbox=function(){function o(){var t=0<arguments.length&&void 0!==arguments[0]?arguments[0]:{};if(_classCallCheck(this,o),_classPrivateMethodInitSpec(this,_addEvents),_classPrivateMethodInitSpec(this,_addButtons),_classPrivateMethodInitSpec(this,_buildModal),_classPrivateMethodInitSpec(this,_getDefaultButtonOptions),_classPrivateFieldInitSpec(this,_options,{writable:!0,value:void 0}),_classPrivateFieldInitSpec(this,_modal,{writable:!0,value:void 0}),_classPrivateFieldInitSpec(this,_modalEl,{writable:!0,value:void 0}),_classPrivateFieldInitSpec(this,_footer,{writable:!0,value:void 0}),_classPrivateFieldSet(this,_options,_objectSpread(_objectSpread({},bootstrap.Modal.Default),{},{id:_classStaticPrivateMethodGet(o,o,_getUID).call(o),icon:null,style:"white",titleStyle:null,title:"Information",body:"",size:null,center:!1,fade:!0,show:!1,scrollable:!0,destroyOnClose:!1,defaultButton:!0,defaultButtonLabel:"Close",swapButtonOrder:!1,justifyButtons:null,buttons:[],events:{}},_classStaticPrivateMethodGet(o,o,_checkUserOptions).call(o,t))),"string"!=typeof _classPrivateFieldGet(this,_options).body||!_classPrivateFieldGet(this,_options).body.length)throw new Error('The "body" configuration option is required (string).');_classPrivateMethodGet(this,_buildModal,_buildModal2).call(this),_classPrivateFieldSet(this,_modal,new bootstrap.Modal(_classPrivateFieldGet(this,_modalEl),{backdrop:(t=_classPrivateFieldGet(this,_options)).backdrop,keyboard:t.keyboard,focus:t.focus})),_classPrivateMethodGet(this,_addEvents,_addEvents2).call(this),!0===_classPrivateFieldGet(this,_options).show&&this.show()}return _createClass(o,[{key:"options",get:function(){return _classPrivateFieldGet(this,_options)}},{key:"modal",get:function(){return _classPrivateFieldGet(this,_modal)}},{key:"modalEl",get:function(){return _classPrivateFieldGet(this,_modalEl)}},{key:"buttons",get:function(){return _toConsumableArray(_classPrivateFieldGet(this,_footer).querySelectorAll("button"))}},{key:"addButton",value:function(){var e=this,t=0<arguments.length&&void 0!==arguments[0]?arguments[0]:{},o=1<arguments.length&&void 0!==arguments[1]?arguments[1]:_classPrivateFieldGet(this,_options).swapButtonOrder;_classPrivateFieldGet(this,_footer).classList.remove("d-none");var a=o?"afterbegin":"beforeend";if("string"==typeof t&&t.length){_classPrivateFieldGet(this,_footer).insertAdjacentHTML(a,t);var n=this.buttons;return n[o?0:n.length-1]}var i=_objectSpread(_objectSpread({},_classPrivateMethodGet(this,_getDefaultButtonOptions,_getDefaultButtonOptions2).call(this)),t);_classPrivateFieldGet(this,_footer).insertAdjacentHTML(a,'\n\t\t\t<button\n\t\t\t\ttype="button"\n\t\t\t\tclass="btn btn-'.concat(i.outline?"outline-":"").concat(i.style," ").concat(i.class," ").concat(i.size?"btn-".concat(i.size):"",'"\n\t\t\t\tid="').concat(i.id,'"\n\t\t\t\t').concat(i.title?'title="'.concat(i.title,'"'):"","\n\t\t\t\t").concat(i.close?'data-bs-dismiss="modal"':"","\n\t\t\t\t").concat(i.disabled?"disabled":"","\n\t\t\t>\n\t\t\t\t").concat(i.icon?'<i class="'.concat(i.icon,' me-2"></i>'):"").concat(i.label,"\n\t\t\t</button>\n\t\t").trim());var r=_classPrivateFieldGet(this,_footer).querySelector("#".concat(i.id));return r&&"function"==typeof i.callback&&r.addEventListener("click",function(t){return i.callback.call(r,t,e)}),r}},{key:"addEvent",value:function(t,e){["show","shown","hide","hidden","hidePrevented"].includes(t)&&"function"==typeof e&&_classPrivateFieldGet(this,_modalEl).addEventListener("".concat(t,".bs.modal"),e)}},{key:"destroy",value:function(){this.dispose(),_classPrivateFieldGet(this,_modalEl).remove()}},{key:"toggle",value:function(){_classPrivateFieldGet(this,_modal).toggle()}},{key:"show",value:function(t){_classPrivateFieldGet(this,_modal).show(t)}},{key:"hide",value:function(){_classPrivateFieldGet(this,_modal).hide()}},{key:"handleUpdate",value:function(){_classPrivateFieldGet(this,_modal).handleUpdate()}},{key:"dispose",value:function(){_classPrivateFieldGet(this,_modal).dispose()}}],[{key:"container",get:function(){var t,e=document.querySelector("#modbox-container");return e||((t=document.createElement("div")).id="modbox-container",e=document.body.appendChild(t)),e}},{key:"alert",value:function(){var t=0<arguments.length&&void 0!==arguments[0]?arguments[0]:{},t=_objectSpread(_objectSpread({},_classStaticPrivateMethodGet(o,o,_deepMerge).call(o,{title:"Alert",closeButton:{}},_classStaticPrivateMethodGet(o,o,_checkUserOptions).call(o,t))),{},{destroyOnClose:!0,defaultButton:!1,buttons:[]});return _classStaticPrivateMethodGet(o,o,_buildPromiseModal).call(o,t)}},{key:"info",value:function(){var t=0<arguments.length&&void 0!==arguments[0]?arguments[0]:{};return o.alert(_objectSpread({style:"info",title:"Information"},_classStaticPrivateMethodGet(o,o,_checkUserOptions).call(o,t)))}},{key:"success",value:function(){var t=0<arguments.length&&void 0!==arguments[0]?arguments[0]:{};return o.alert(_objectSpread({style:"success",title:"Success"},_classStaticPrivateMethodGet(o,o,_checkUserOptions).call(o,t)))}},{key:"danger",value:function(){var t=0<arguments.length&&void 0!==arguments[0]?arguments[0]:{};return o.alert(_objectSpread({style:"danger",title:"Error"},_classStaticPrivateMethodGet(o,o,_checkUserOptions).call(o,t)))}},{key:"error",value:function(){return o.danger(0<arguments.length&&void 0!==arguments[0]?arguments[0]:{})}},{key:"confirm",value:function(){var t=0<arguments.length&&void 0!==arguments[0]?arguments[0]:{},t=_objectSpread(_objectSpread({},_classStaticPrivateMethodGet(o,o,_deepMerge).call(o,{title:"Confirm",okButton:{label:"OK",style:"primary"},closeButton:{label:"Cancel"}},_classStaticPrivateMethodGet(o,o,_checkUserOptions).call(o,t))),{},{destroyOnClose:!0,defaultButton:!1,buttons:[]});return _classStaticPrivateMethodGet(o,o,_buildPromiseModal).call(o,t,"confirm")}},{key:"prompt",value:function(){var t=0<arguments.length&&void 0!==arguments[0]?arguments[0]:{},e={title:"Prompt",input:{id:_classStaticPrivateMethodGet(o,o,_getUID).call(o,"modbox-input-"),type:"text",class:"",value:"",title:null,placeholder:null,autocomplete:"off",minlength:null,maxlength:null,pattern:null,required:!1,_validate:!1},okButton:{label:"OK",style:"primary"},closeButton:{label:"Cancel"}},e=_objectSpread(_objectSpread({},_classStaticPrivateMethodGet(o,o,_deepMerge).call(o,e,_classStaticPrivateMethodGet(o,o,_checkUserOptions).call(o,t))),{},{destroyOnClose:!0,defaultButton:!1,buttons:[]});return"regexp"===_classStaticPrivateMethodGet(o,o,_typeof).call(o,null===(t=e.input)||void 0===t?void 0:t.pattern)&&(e.input.pattern=e.input.pattern.source),(!0===e.input.required||"number"==typeof e.input.minlength||"string"==typeof e.input.pattern&&e.input.pattern.length)&&(e.okButton.close=!1,e.input._validate=!0),e.body="\n\t\t\t".concat(e.body?"<p>".concat(e.body,"</p>"):"","\n\t\t\t").concat("string"==typeof e.input?e.input:'<input\n\t\t\t\t\ttype="'.concat(e.input.type,'"\n\t\t\t\t\tclass="form-control ').concat(e.input.class,'"\n\t\t\t\t\tid="').concat(e.input.id,'"\n\t\t\t\t\tvalue="').concat(e.input.value,'"\n\t\t\t\t\t').concat(e.input.title?'title="'.concat(e.input.title,'"'):"","\n\t\t\t\t\t").concat(e.input.placeholder?'placeholder="'.concat(e.input.placeholder,'"'):"","\n\t\t\t\t\t").concat(e.input.autocomplete?'autocomplete="'.concat(e.input.autocomplete,'"'):"","\n\t\t\t\t\t").concat("number"==typeof e.input.minlength?'minlength="'.concat(e.input.minlength,'"'):"","\n\t\t\t\t\t").concat("number"==typeof e.input.maxlength?'maxlength="'.concat(e.input.maxlength,'"'):"","\n\t\t\t\t\t").concat("string"==typeof e.input.pattern&&e.input.pattern.length?'pattern="'.concat(e.input.pattern,'"'):"","\n\t\t\t\t\t").concat(e.input.required?"required":"","\n\t\t\t\t>"),"\n\t\t").trim(),_classStaticPrivateMethodGet(o,o,_buildPromiseModal).call(o,e,"prompt")}},{key:"getInstance",value:function(t){return bootstrap.Modal.getInstance(t)}},{key:"getOrCreateInstance",value:function(t){return bootstrap.Modal.getOrCreateInstance(t)}}]),o}();function _getUID(){return(0<arguments.length&&void 0!==arguments[0]?arguments[0]:"modbox-")+Math.floor(1e6*Math.random())}function _typeof(t){return"object"==typeof t?Object.prototype.toString.call(t).slice(8,-1).toLowerCase():typeof t}function _deepMerge(a,n){var i=_objectSpread(_objectSpread({},a),n);return Object.keys(i).forEach(function(t){var e=a[t],o=n[t];"object"===_classStaticPrivateMethodGet(modbox,modbox,_typeof).call(modbox,e)&&"object"===_classStaticPrivateMethodGet(modbox,modbox,_typeof).call(modbox,o)&&(i[t]=_classStaticPrivateMethodGet(modbox,modbox,_deepMerge).call(modbox,e,o))}),i}function _checkUserOptions(t){return"string"==typeof t?{body:t}:t}function _buildPromiseModal(){var r=0<arguments.length&&void 0!==arguments[0]?arguments[0]:{},l=1<arguments.length&&void 0!==arguments[1]?arguments[1]:"alert";return new Promise(function(e,t){var o,a=new modbox(r),n=[r.closeButton];["confirm","prompt"].includes(l)&&(o=function(){return e()},"prompt"===l&&"object"===_classStaticPrivateMethodGet(modbox,modbox,_typeof).call(modbox,r.input)&&(o=function(){var t=a.modalEl.querySelector("#".concat(r.input.id));!0===r.input._validate&&!t.reportValidity()||(a.hide(),e(t.value))}),n.unshift(_objectSpread(_objectSpread({},r.okButton),{},{callback:function(t,e){"function"==typeof r.okButton.callback&&r.okButton.callback.call(this,t,e),o()}})));var n=_slicedToArray(n.map(function(t){return a.addButton(t)}),2),i=n[0];n[1];a.addEvent("hide",function(){"alert"===l?e():["confirm","prompt"].includes(l)&&document.activeElement!==i&&t()}),a.show()})}function _getDefaultButtonOptions2(){var t=0<arguments.length&&void 0!==arguments[0]?arguments[0]:"Close";return{id:_classStaticPrivateMethodGet(modbox,modbox,_getUID).call(modbox,"modbox-btn-"),label:t,style:"secondary",class:"",outline:!1,size:null,icon:null,title:null,disabled:!1,close:!0,callback:null}}function _buildModal2(){var t=["primary","secondary","success","danger","dark","body"].includes(_classPrivateFieldGet(this,_options).style),e=_classPrivateFieldGet(this,_options).titleStyle||(t?"white":"dark"),o="btn-close ".concat(t?"btn-close-white":""),t="";_classPrivateFieldGet(this,_options).title&&(t='\n\t\t\t\t<div class="modal-header '.concat(_classPrivateFieldGet(this,_options).style?"bg-".concat(_classPrivateFieldGet(this,_options).style):"",'">\n\t\t\t\t\t<h5 class="modal-title text-').concat(e,'">').concat(_classPrivateFieldGet(this,_options).icon?'<i class="'.concat(_classPrivateFieldGet(this,_options).icon,' me-3"></i>'):"").concat(_classPrivateFieldGet(this,_options).title,'</h5>\n\t\t\t\t\t<button type="button" class="').concat(o,'" data-bs-dismiss="modal"></button>\n\t\t\t\t</div>\n\t\t\t').trim()),modbox.container.insertAdjacentHTML("beforeend",'\n\t\t\t<div class="modal '.concat(_classPrivateFieldGet(this,_options).fade?"fade":"",'" id="').concat(_classPrivateFieldGet(this,_options).id,'" tabindex="-1">\n\t\t\t\t<div class="modal-dialog ').concat(_classPrivateFieldGet(this,_options).scrollable?"modal-dialog-scrollable":""," ").concat(_classPrivateFieldGet(this,_options).center?"modal-dialog-centered":""," ").concat(_classPrivateFieldGet(this,_options).size?"modal-".concat(_classPrivateFieldGet(this,_options).size):"",'">\n\t\t\t\t\t<div class="modal-content">\n\t\t\t\t\t\t').concat(t,'\n\t\t\t\t\t\t<div class="modal-body">\n\t\t\t\t\t\t\t').concat(_classPrivateFieldGet(this,_options).body,'\n\t\t\t\t\t\t</div>\n\t\t\t\t\t\t<div class="modal-footer ').concat(_classPrivateFieldGet(this,_options).justifyButtons?"d-flex justify-content-".concat(_classPrivateFieldGet(this,_options).justifyButtons):"",'"></div>\n\t\t\t\t\t</div>\n\t\t\t\t</div>\n\t\t\t</div>\n\t\t').trim()),_classPrivateFieldSet(this,_modalEl,modbox.container.querySelector("#".concat(_classPrivateFieldGet(this,_options).id))),_classPrivateFieldSet(this,_footer,_classPrivateFieldGet(this,_modalEl).querySelector(".modal-footer")),_classPrivateMethodGet(this,_addButtons,_addButtons2).call(this)}function _addButtons2(){var e=this;Array.isArray(_classPrivateFieldGet(this,_options).buttons)||(_classPrivateFieldGet(this,_options).buttons=[]),0===_classPrivateFieldGet(this,_options).buttons.length&&!0===_classPrivateFieldGet(this,_options).defaultButton?_classPrivateFieldGet(this,_options).buttons=[_classPrivateMethodGet(this,_getDefaultButtonOptions,_getDefaultButtonOptions2).call(this,_classPrivateFieldGet(this,_options).defaultButtonLabel)]:_classPrivateFieldGet(this,_footer).classList.add("d-none"),_classPrivateFieldGet(this,_options).buttons.forEach(function(t){return e.addButton(t)})}function _addEvents2(){var o=this;Object.entries(_classPrivateFieldGet(this,_options).events).forEach(function(t){var e=_slicedToArray(t,2),t=e[0],e=e[1];o.addEvent(t,e)}),!0===_classPrivateFieldGet(this,_options).destroyOnClose&&this.addEvent("hidden",function(){return o.destroy()})}_defineProperty(modbox,"version","1.0.0");
//# sourceMappingURL=bootstrap-modbox.compat.min.js.map